/*
 * GlushkovPair.h
 *
 *  Created on: 14. 4. 2014
 *      Author: Tomas Pecka
 */

#ifndef GLUSHKOVPAIR_H_
#define GLUSHKOVPAIR_H_

#include "GlushkovSymbol.h"

namespace regexp {

/**
 * Actually, this is just std::pair. 2-tuple.
 */
class GlushkovPair
{
private:
    GlushkovSymbol const m_first;
    GlushkovSymbol const m_second;

public:
    GlushkovPair( GlushkovSymbol const& first, GlushkovSymbol const& second );
    bool operator<( GlushkovPair const& x ) const;
    GlushkovSymbol const& getFirst( void ) const;
    GlushkovSymbol const& getSecond( void ) const;
};
} /* namespace conversions */

#endif /* GLUSHKOVPAIR_H_ */
