#include "GrammarToStringComposer.h"
#include "../alphabet/SymbolToStringComposer.h"
#include <sstream>

namespace grammar {

std::string GrammarToStringComposer::compose(const GrammarBase& grammar) const {

}

std::string GrammarToStringComposer::compose(const Grammar& grammar) const {
	std::stringstream out;
	grammar.getData().Accept((void*) &out, *this);
	return out.str();
}

std::string GrammarToStringComposer::compose(const LeftLG& grammar) const {
	// TODO
}

std::string GrammarToStringComposer::compose(const LeftRG& grammar) const {
	// TODO
}

std::string GrammarToStringComposer::compose(const RightLG& grammar) const {
	// TODO
}

std::string GrammarToStringComposer::compose(const RightRG& grammar) const {
	// TODO
}

std::string GrammarToStringComposer::compose(const LG& grammar) const {
	// TODO
}

std::string GrammarToStringComposer::compose(const CFG& grammar) const {
	// TODO
}

std::string GrammarToStringComposer::compose(const EpsilonFreeCFG& grammar) const {
	// TODO
}

std::string GrammarToStringComposer::compose(const CNF& grammar) const {
	// TODO
}

std::string GrammarToStringComposer::compose(const GNF& grammar) const {
	// TODO
}

std::string GrammarToStringComposer::compose(const CSG& grammar) const {
	// TODO
}

std::string GrammarToStringComposer::compose(const NonContractingGrammar& grammar) const {
	// TODO
}

std::string GrammarToStringComposer::compose(const ContextPreservingUnrestrictedGrammar& grammar) const {
	// TODO
}

std::string GrammarToStringComposer::compose(const UnrestrictedGrammar& grammar) const {
	// TODO
}

void GrammarToStringComposer::Visit(void* data, const LeftLG& grammar) const {
	*((std::stringstream*) data) << this->compose(grammar);
}

void GrammarToStringComposer::Visit(void* data, const LeftRG& grammar) const {
	*((std::stringstream*) data) << this->compose(grammar);
}

void GrammarToStringComposer::Visit(void* data, const RightLG& grammar) const {
	*((std::stringstream*) data) << this->compose(grammar);
}

void GrammarToStringComposer::Visit(void* data, const RightRG& grammar) const {
	*((std::stringstream*) data) << this->compose(grammar);
}

void GrammarToStringComposer::Visit(void* data, const LG& grammar) const {
	*((std::stringstream*) data) << this->compose(grammar);
}

void GrammarToStringComposer::Visit(void* data, const CFG& grammar) const {
	*((std::stringstream*) data) << this->compose(grammar);
}

void GrammarToStringComposer::Visit(void* data, const EpsilonFreeCFG& grammar) const {
	*((std::stringstream*) data) << this->compose(grammar);
}

void GrammarToStringComposer::Visit(void* data, const CNF& grammar) const {
	*((std::stringstream*) data) << this->compose(grammar);
}

void GrammarToStringComposer::Visit(void* data, const GNF& grammar) const {
	*((std::stringstream*) data) << this->compose(grammar);
}

void GrammarToStringComposer::Visit(void* data, const CSG& grammar) const {
	*((std::stringstream*) data) << this->compose(grammar);
}

void GrammarToStringComposer::Visit(void* data, const NonContractingGrammar& grammar) const {
	*((std::stringstream*) data) << this->compose(grammar);
}

void GrammarToStringComposer::Visit(void* data, const ContextPreservingUnrestrictedGrammar& grammar) const {
	*((std::stringstream*) data) << this->compose(grammar);
}

void GrammarToStringComposer::Visit(void* data, const UnrestrictedGrammar& grammar) const {
	*((std::stringstream*) data) << this->compose(grammar);
}

}
