#ifndef __PAIR_HPP_
#define __PAIR_HPP_

#include <map>

namespace std {

template< class T, class R >
std::ostream& operator<<(std::ostream& out, const std::pair<T, R>& pair);

}

#include "set.hpp"
#include "map.hpp"
#include "list.hpp"
#include "tuple.hpp"
#include "vector.hpp"
#include <iostream>

namespace std {

template< class T, class R >
std::ostream& operator<<(std::ostream& out, const std::pair<T, R>& pair) {
	out << "(" << pair.first << ", " << pair.second << ")";
	return out;
}

} /* namespace std */

#endif /* __PAIR_HPP_ */

