#ifndef STRING_TEST_H_
#define STRING_TEST_H_

#include <cppunit/extensions/HelperMacros.h>

class StringTest : public CppUnit::TestFixture
{
	CPPUNIT_TEST_SUITE( StringTest );
	CPPUNIT_TEST( testCopyConstruct );
	CPPUNIT_TEST( testEqual );
	CPPUNIT_TEST( testXMLParser );
	CPPUNIT_TEST( testCompare );
	CPPUNIT_TEST( testCompareCyclic );
	CPPUNIT_TEST( testStringInMap );
	CPPUNIT_TEST_SUITE_END();

public:
	void setUp();
	void tearDown();

	void testCopyConstruct();
	void testEqual();
	void testXMLParser();
	void testCompare();
	void testCompareCyclic();
	void testStringInMap();
};

#endif	// STRING_TEST_H_
