#ifndef DETERMINIZE_TEST_H_
#define DETERMINIZE_TEST_H_

#include <cppunit/extensions/HelperMacros.h>

class determinizeTest : public CppUnit::TestFixture
{
  CPPUNIT_TEST_SUITE( determinizeTest );
  CPPUNIT_TEST( testDeterminizeNFA );
  CPPUNIT_TEST( testDeterminizeIDPDA );
  CPPUNIT_TEST( testDeterminizeVPA );
  CPPUNIT_TEST_SUITE_END();

public:
  void setUp();
  void tearDown();

  void testDeterminizeNFA();
  void testDeterminizeIDPDA();
  void testDeterminizeVPA();
};

#endif  // DETERMINIZE_TEST_H_
