/*
 * Shift.h
 *
 *  Created on: Oct 13, 2013
 *      Author: Martin Zak
 */

#ifndef SHIFT_H_
#define SHIFT_H_

#include <string>

namespace automaton {

/**
 * Represent movement of the reading head in the Turing machine.
 */
enum Shift {
	LEFT, RIGHT, NONE, NOT_SET
};

extern std::string SHIFT_NAMES[4];

} /* namespace automaton */

#endif /* SHIFT_H_ */
