/*
 * GrammarFeatures.h
 *
 *  Created on: Jun 19, 2014
 *      Author: Jan Travnicek
 */

#ifndef GRAMMAR_FEATURES_H_
#define GRAMMAR_FEATURES_H_

namespace grammar {

enum class FEATURES {
	LEFT_LG,
	LEFT_RG,
	RIGHT_LG,
	RIGHT_RG,
	LG,
	CFG,
	EPSILON_FREE_CFG,
	CNF,
	GNF,
	CSG,
	NON_CONTRACTING_GRAMMAR,
	CONTEXT_PRESERVING_UNRESTRICTED_GRAMMAR,
	UNRESTRICTED_GRAMMAR
};

} /* namespace grammar */

#endif /* GRAMMAR_FEATURES_H_ */
