/*
 * String.cpp
 *
 *  Created on: Apr 16, 2013
 *      Author: Jan Travnicek
 */

#include "String.h"
#include "LinearString.h"
#include "../exception/AlibException.h"

namespace string {

string::String symbolFrom( const alphabet::Symbol& symbol ) {
	return string::String { string::LinearString { std::vector<alphabet::Symbol> { symbol } } };
}

string::String symbolFrom( const std::string& string ) {
	return string::String { string::LinearString { string } };
}

} /* namespace string */

