#ifndef VISITOR_TEST_H_
#define VISITOR_TEST_H_

#include <cppunit/extensions/HelperMacros.h>

class StdVisitorTest : public CppUnit::TestFixture
{
  CPPUNIT_TEST_SUITE( StdVisitorTest );
  CPPUNIT_TEST( testPromoteVisitor );
  CPPUNIT_TEST( testSameVisitor );
  CPPUNIT_TEST( testVisitor );
  CPPUNIT_TEST_SUITE_END();

public:
  void setUp();
  void tearDown();

  void testPromoteVisitor();
  void testSameVisitor();
  void testVisitor();
};

#endif  // VISITOR_TEST_H_
